/*
ISR speziell fr IAR-Compiler mit reservierten Registern

Michael Nowak
www.mino-elektronik.de
2020-04-20
*/
#include <iotiny416.h>

#define TEST_PB5      // Laufzeitmessung
#define PORT_MUSTER (PIN6_bm | PIN7_bm)    // PA6 und PA7

#define wechsel     r6
#define pina_alt    r7
#define cnt0        r8
#define cnt1        r9
#define cnt2        r10
#define cnt3        r11
#define temp_0xc0   r12
#define regff       r13
#define sreg_temp   r14
#define temp_pina   r15

public lese_cnt, schreibe_cnt, init_clear_cnt

COMMON INTVEC(1)

org TCA0_OVF_vect
            jmp timer0_comp0a


rseg CODE

timer0_comp0a:  
            in sreg_temp,SREG         ;status merken
            out GPIO0,r16
#ifdef TEST_PB5            
            ldi r16, PIN5_bm
            sts PORTB_OUTSET, r16
#endif
            ldi r16, TCA_SINGLE_OVF_bm  ; ISR-Flag lschen
            sts TCA0_SPLIT_INTFLAGS, r16
            in r16, GPIO0
            in temp_pina,VPORTA_IN
            mov wechsel, temp_pina
            eor wechsel, pina_alt
            mov pina_alt, temp_pina
            sbis VPORTA_IN, PIN3_bp   ; PA3 auf Reset testen
            rjmp reset_cnt
            and wechsel, temp_0xc0
            breq cnt_up_end           ;keine Aenderung
            rol wechsel
            and wechsel, temp_0xc0
            breq int1_wechsel
            rjmp int0_wechsel
                
reset_cnt:  clr cnt0
            clr cnt1
            clr cnt2
            clr cnt3
            rjmp cnt_up_end

int0_wechsel:
            and temp_pina,temp_0xc0
            breq cnt_up
            cp temp_pina,temp_0xc0
            brne cnt_down
cnt_up:     sub cnt0,regff
            sbc cnt1,regff
            sbc cnt2,regff
            sbc cnt3,regff
cnt_up_end: out SREG,sreg_temp
#ifdef TEST_PB5 
            out GPIO0,r16
            ldi r16, PIN5_bm
            sts PORTB_OUTCLR, r16
            in r16, GPIO0
#endif
            reti


int1_wechsel:
            and temp_pina,temp_0xc0
            breq cnt_down
            cp temp_pina,temp_0xc0
            brne cnt_up
cnt_down:   add cnt0,regff
            adc cnt1,regff
            adc cnt2,regff
            adc cnt3,regff
cnt_down_end:
            out SREG,sreg_temp
            reti


lese_cnt:   cli
            mov r16,cnt0
            mov r17,cnt1
            mov r18,cnt2
            mov r19,cnt3
            sei
            ret

schreibe_cnt:
            cli
            mov cnt0,r16
            mov cnt1,r17
            mov cnt2,r18
            mov cnt3,r19
            sei
            ret



init_clear_cnt:
            cli
            clr cnt0
            clr cnt1  
            clr cnt2
            clr cnt3
            in pina_alt, VPORTA_IN
            ldi r16,PORT_MUSTER
            mov temp_0xc0,r16
            ldi r16,-1
            mov regff,r16
#ifdef TEST_PB5 
            ldi r16, PIN5_bm        ; PB5 auf Ausgang
            sts PORTB_DIRSET, r16
#endif
            sei
            ret


end